



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SpringCloud系列——Bus 消息总线</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SpringCloud系列——Bus 消息总线</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 17:21:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>　　前言</h2>
<p>　　SpringCloud Bus使用轻量级消息代理将分布式系统的节点连接起来。然后可以使用此代理广播状态更改(例如配置更改)或其他管理指令。本文结合RabbitMQ+GitHub的Webhook实现上篇博客Config配置中心（<a href="https://www.cnblogs.com/huanzi-qch/p/10149547.html" rel="external nofollow noreferrer">SpringCloud系列&mdash;&mdash;Config 配置中心</a>）的自动刷新</p>
<p>　　官方文档：<a href="https://cloud.spring.io/spring-cloud-static/spring-cloud-bus/2.1.0.RC3/single/spring-cloud-bus.html" rel="external nofollow noreferrer">https://cloud.spring.io/spring-cloud-static/spring-cloud-bus/2.1.0.RC3/single/spring-cloud-bus.html</a></p>
<h2>　　RabbitMQ安装</h2>
<p>　　参考：<a href="https://www.cnblogs.com/zhangweizhong/p/5689209.html" rel="external nofollow noreferrer">https://www.cnblogs.com/zhangweizhong/p/5689209.html</a></p>
<p>　　大概步骤：</p>
<p>　　1、先去下载Erlang、RabbitMQ</p>
<p>　　2、先安装Erlang环境、配置ERLANG_HOME环境变量、安装RabbitMQ</p>
<p>　　3、激活RabbitMQ 管理插件，登录http://localhost:15672，使用默认账号登录，用户名、密码都是：guest</p>
<p>　　</p>
<h2>　　代码编写</h2>
<p>　　确保RabbitMQ中间件可用之后我们开始对上一篇的项目进行调整，我这里直接使用默认账号连接RabbitMQ，5672是RabbitMQ的监听端口</p>
<h3>　　Config Server</h3>
<p>　　maven引入bus-amqp</p>
<div>
<pre class="prettyprint linenums">        &lt;!-- bus-RabbitMQ --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework.cloud&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-cloud-starter-bus-amqp&lt;/artifactId&gt;<br />
        &lt;/dependency&gt;</pre>
</div>
<p>　　配置文件添加对RabbitMQ的相关配置</p>
<div>
<pre class="prettyprint linenums">#bus-rabbitMQ<br />
spring.cloud.bus.trace.enabled=true<br />
spring.rabbitmq.host=localhost<br />
spring.rabbitmq.port=<br />
spring.rabbitmq.username=guest<br />
spring.rabbitmq.password=guest</pre>
</div>
<p>　　同时，配置中心担任调用/bus-refresh的任务</p>
<div>
<pre class="prettyprint linenums">#暴露端点<br />
management.endpoints.web.exposure.include=bus-refresh</pre>
</div>
<p>　　</p>
<h3>　　Config Client</h3>
<p>　　客户端同时也要连接到消息总线</p>
<p>　　maven引jar</p>
<div>
<pre class="prettyprint linenums">        &lt;!-- bus-RabbitMQ --&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework.cloud&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-cloud-starter-bus-amqp&lt;/artifactId&gt;<br />
        &lt;/dependency&gt;</pre>
</div>
<p>　　配置文件添加</p>
<div>
<pre class="prettyprint linenums">#bus-rabbitMQ<br />
spring.cloud.bus.trace.enabled=true<br />
spring.rabbitmq.host=localhost<br />
spring.rabbitmq.port=<br />
spring.rabbitmq.username=guest<br />
spring.rabbitmq.password=guest</pre>
</div>
<h2>　　效果演示</h2>
<p>　　启动所有项目</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221120425232-1045269360.png" /></p>
<p>　　Config Server访问 http://localhost:1112/myspringboot-dev.properties/</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221120533487-63525170.png" /></p>
<p>　　Config Server访问 http://localhost:10087/index</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221120615691-484773950.png" /></p>
<p>　　前往GitHub修改&nbsp;huanzi.qch.config.server.username: 张三2</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221120725253-1861299848.png" /></p>
<p>　　修改完之后回去刷新Config Server跟Config Client，server能实时更新获取最新数据，client不能实时获取最新数据，读的是缓存</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221120946077-474719687.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221120956743-303980534.png" /></p>
<p>　　Config Server post调用 http://localhost:1112/actuator/bus-refresh</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221121045921-1220306363.png" /></p>
<p>　　打印空？没关系，刷新Config Client的http://localhost:10087/index，已经获取到了最新数据</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221121156123-1549845117.png" /></p>
<h2>　　WebHook</h2>
<p>　　GitHub的webhook允许在某些事件发生时通知外部服务。当指定的事件发生时，我们将向您提供的每个url发送POST请求。</p>
<p>　　登录GitHub，前往创建一个WebHook</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221121546136-1194304638.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221122232086-272770268.png" /></p>
<p>　　需要能被外网访问，所以这里演示不了...</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1353055/201812/1353055-20181221140831501-810724714.png" /></p>
<p>　　这样，在每次push之后都会触发webhook事件，从而实现Config配置中心的自动刷新</p>
<h2>　　总结</h2>
<p>　　更多springcloud bus配置请查阅官方文档</p>
<h2>　　代码开源</h2>
<p>　　代码已经开源、托管到我的GitHub、码云：</p>
<p>　　GitHub：<a href="https://github.com/huanzi-qch/springCloud" rel="external nofollow noreferrer">https://github.com/huanzi-qch/springCloud</a></p>
<p>　　码云：<a href="https://gitee.com/huanzi-qch/springCloud" rel="external nofollow noreferrer">https://gitee.com/huanzi-qch/springCloud</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zn1n8y.html">Oracle逻辑迁移某业务用户及数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlk1668.html">winform客户端利用webClient实现与Web服务端的数据传输</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1pzx9.html">C&num; 常用的dialogresult reset 以及if else 等检查获取客户操作信息的操作方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvkj6yq.html">转】Maven学习总结&lpar;二&rpar;&mdash;&mdash;Maven项目构建过程练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zdmo69.html">从零学习IOS-VirtualBox-4&period;3&period;20-96997-Win</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvp07yq.html">spring beans源码解读之--bean definiton解析器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j04l5wq.html">《JavaScript语言精髓与编程实践》读书笔记二</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnv2jv8.html">Android studio  开发中 用git实现批量忽略特定文件的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mv01j8.html">解决AngularJS和Django模板标签冲突问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzvvre8.html">【Beta】Daily Scrum Meeting&mdash;&mdash;Day3</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k2ng49.html">自己模拟的一个简单的web服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z5x6e9.html">python day two&comma;while</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp7goj9.html">LOJ&num;2244 起床困难综合症</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eynoxj9.html">rabbitmq&period;config配置参数详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjmj39.html">Pip无法卸载某些包：Cannot uninstall &amp;&num;39&semi;PyYAML&amp;&num;39&semi;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1d1rxq.html">Python之操作redis数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjkd6l9.html">Java开源博客My-Blog之mysql容器重复初始化的严重bug修复过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rnzl48.html">（转）Maven之自定义archetype生成项目骨架</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7exjve9.html">Scala学习&lpar;二&rpar;练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/963yr5y9.html">&lbrack;leetcode&rsqb;228&period; Summary Ranges区间统计</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1yew1q.html">BZOJ&lowbar;4443&lowbar;&lbrack;Scoi2015&rsqb;小凸玩矩阵&lowbar;二分&plus;二分图匹配</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyg07x9.html">Spring  py登陆模块（包含 记录登陆时间，记录ip，增加积分）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge755l8.html">深入理解OkHttp源码（一）&mdash;&mdash;提交请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/96prdvn8.html">&period;net core 2&period;0 redis驱动性能比拼</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m345j8.html">Git常用命令拾遗</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m343j8.html">LeetCode二叉树的前序、中序、后序遍历（递归实现）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpygyvq.html">synchronized关键字简介 多线程中篇（十一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me5rkpq.html">学习python的第一天</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpyxkzq.html">SharePoint布局页引用（实战）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jzvvv8.html">Windows无人值守文件unattend制作以及自定义系统安装</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
